#!/usr/bin/php
<?php

include_once "smsreceiver.inc.php";
include_once "utils.php";


#$debug=1;

/* Testing stuf... */
/*
$smsfile="/root/sms/testsms";
$type = "RECEIVED";
*/


# Process arguments. Call using eg
# smsreceiver.php <type> <smsfile>
# where <type> should be RECEIVED
if($argc>2){
	$smsfile = $argv[2];
	$type = $argv[1];
} else {
	printLog("Too few arguments...");
	exit(1);
}

if($type!="RECEIVED"){
	printLog("sms type is $type. Not RECEIVED as expected, aborting");
#	deletefile($smsfile);
	exit(0);
}


printLog("Received sms '$smsfile'");


$smsdconfig = Array();

# Fetch config
$smsdconfig = processConfigFile($configfile);

# Build white/blackList (if option exist in config)
if(isset($smsdconfig['whitelist']))
  $whitelist = buildList($smsdconfig['whitelist']);
if(isset($smsdconfig['blacklist']))	
  $blacklist = buildList($smsdconfig['blacklist']);

#Process sms
$smsmessage = processMessage($smsfile);

#$sender=$smsmessage["from"];
#$str=$smsmessage["content"];
#$retval=`/home/peter/sms-reciever/smsacknowledge.php $smsfile`;

#echo "retval: $retval\n";
#exit(0);
if(isset($debug))
  var_dump($smsmessage);

# Check white and black lists. 
# Discard sms if in black or not in white.
if(isset($whitelist)){
	if(!in_array($smsmessage['from'],$whitelist)){
		printLog('Sender not in whitelist, discarding sms');
		deletefile($smsfile);
		exit(1);
	}
}
if(isset($blacklist)){
	if(in_array($smsmessage['from'],$blacklist)){
		printLog('Sender in blacklist, discarding sms');
		deletefile($smsfile);
		exit(1);
	}
}
 
# Select and do action
foreach($actionMap as $actionkey => $action){
#echo "$actionkey, $action\n";
	if(strncasecmp($actionkey, $smsmessage['content'], strlen($actionkey)) === 0){
#		echo "$actionkey gives $action\n";
		printLog("Action '$action'");
		$retval=`$action $smsfile` ;
#		echo $retval;
		exit(0);
		break;
	} 
}

# Fallback, needed to support acknowledgements that is just
# an reply of the problem message.
printLog("Action '$defaultAction'");
# $defaultAction($smsmessage);

$retval=`$defaultAction $smsfile`;
#var_dump($action);

exit(0);



# Process the sms, build array with 2 elements
# $message['from'] = sending number
# $message['content'] = the actual message
function processMessage($smsfile){
	
	if(!file_exists($smsfile)){
		printLog("SMS file '$smsfile' not found\n");
		exit(1);
	}
	$message = Array();
	$fileArr = file($smsfile);
	$lastrow ='';
	foreach($fileArr as $row){
		if(strncmp($row,"From:",5) === 0){
#			$message['from'] = trim(strpbrk($row,":"),": \n");
			$message['from'] = trim(substr($row,5)," \n");
			continue;
		}	
#		if(strncmp($row,"From_SMSC:",10) === 0){
#			$message['from_smcs'] = trim(substr($row,10)," \n");
#			continue;
#		}
		$lastrow = $row;
	}
	$message['content'] = trim($lastrow, "\n ");
	return $message;
}

# Build an array of white/blacklisted numbers
function buildList($listfile){
	$numberlist = Array();
	if(!file_exists($listfile)){
		printLog("File '$listfile' not found");
		exit(1);
	}
	$fileArr = file($listfile);
	foreach($fileArr as $row){
		$row = trim($row);
		if($row === '' || $row[0] ==='#')
		  continue;
		$tmpArr = explode('#',$row);
		$numberlist[] = trim($tmpArr[0]);
	}
	return $numberlist;
}


# Read smsd.conf. Build array of config options.
function processConfigFile($configfile){
	$config = Array();
	if(!file_exists($configfile)){
		printLog("File '$configfile' not found");
		exit(1);
	}
	$fileArr = file($configfile);
	foreach($fileArr as $row){
		$row = trim($row);
		if($row === '' || $row[0] ==='#' || $row[0] ==='[')
		  continue;
		$tmpArr = explode('=', $row);
		$thekey = trim($tmpArr[0]);
		$config[$thekey] = trim($tmpArr[1]);
	}
	return $config;	
}




?>
